; Message Box
; may 1998
; bum-rak Choi


PRO ClsMsgBox__DEFINE
	struct = { ClsMsgBox, $
				sNumLines:0, $
				iWidgetId:0L, $
				pstrMsg:PTR_NEW() $
			}

END


; ---------- member funcitons -----------------
; PRO ClsMsgBox::initObj, widId, lines
; PRO ClsMsgBox::setNumLines, sLines
; PRO ClsMsgBox::clear
; PRO ClsMsgBox::CLEANUP
; FUNCTION ClsMsgBox::sNumLines
; FUNTION ClsMsgBox::strAt, Ind
; PRO ClsMsgBox::addStr, aStr
; PRO ClsMsgBox::show


; ---------------------------------------------


PRO ClsMsgBox::initObj, widId, lines
	self.iWidgetId = widId
	self->setNumLines, lines
END

PRO ClsMsgBox::setNumLines, sLines
	self.sNumLines = sLines
	self->clear
	tmpStr = STRARR(sLines)
	self.pstrMsg = PTR_NEW(tmpStr, /NO_COPY)
END

PRO ClsMsgBox::clear
	IF (PTR_VALID(self.pstrMsg)) THEN PTR_FREE, self.pstrMsg
END

PRO ClsMsgBox::CLEANUP
	self->clear
END

FUNCTION ClsMsgBox::sNumLines
	RETURN, self.sNumLines
END


FUNCTION ClsMsgBox::strAt, Ind
	IF (ind GE self.sNumLines) THEN ind = self.sNumLines
	RETURN, (*(self.pstrMsg))[Ind]
END


PRO ClsMsgBox::addStr, aStr, SAY=SAY
	FOR I=0, self.sNumLines-2 DO $
		(*(self.pstrMsg))[I] = (*(self.pstrMsg))[I+1]
	(*(self.pstrMsg))[self.sNumLines-1] = aStr
	self->show
	IF ( KEYWORD_SET(SAY) AND (!VERSION.OS EQ 'darwin')) THEN BEGIN ; Say the message
	   SPAWN, 'say ' + ' DONE '
  END
END


PRO ClsMsgBox::show
	WIDGET_CONTROL, self.iWidgetId, SET_VALUE = (*(self.pstrMsg))
END

