
 
#ifndef StcCellContainer_H
#define StcCellContainer_H

#ifdef __cplusplus 
	extern "C" {
#endif


#include "StcCell.h"
//#include "CellML_Mahajan.h"
//#include "CellML_PanditRatCM.h"
//#include "CellML_SachseFB.h"

// stupid way but good start
#define MAX_N_TYPE 10
// enum CellType {MAHAJAN, RAT, FIBROBLAST};

// StcMultiCellContainer.h
typedef struct {
	int iNCell;
	int iNStcCell;
	int arrType[MAX_N_TYPE];
	StcCell *pCell[MAX_N_TYPE];
	int iMemFlag_temp;
	TypeCellML *d_temp;
} StcCellContainer ;


StcCellContainer *ctn_prototype(void);
void ctn_freeStcCellContainer(StcCellContainer *);
int ctn_addCell(StcCellContainer *, StcCell *);
//void ctn_removeCell(int );
//void ctn_allocMemoryOnCuda(void);
void ctn_iterate(StcCellContainer *, TypeCellML );

//void ctn_getValue_device(StcCellContainer *, TypeCellML *, int *, CellMLVarType );
void ctn_getValueSorted_device(StcCellContainer *, int *, enum CellMLVarType);
void ctn_getCtnValueToHost(StcCellContainer *, TypeCellML *);

void ctn_getVm(StcCellContainer *, TypeCellML *);
void ctn_setVm(StcCellContainer *, TypeCellML *);
void ctn_setTemp(StcCellContainer *, TypeCellML *);
void ctn_setStim(StcCellContainer *); // use temp array

void ctn_setValue_SingleCellType(StcCellContainer *, TypeCellML *, int , enum CellMLVarType, int);
//void ctn_setValueSorted(StcCellContainer *, TypeCellML *, int *, CellMLVarType);
//void ctn_setCtnValueToDevice(StcCellContainer *, TypeCellML *);




#ifdef __cplusplus
}
#endif

#endif

